// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"encoding/json"
	"github.com/oracle/oci-go-sdk/v45/common"
)

// ContainerScanRegistry Registry information for a container scan target
type ContainerScanRegistry interface {

	// URL of the registry.
	GetUrl() *string
}

type containerscanregistry struct {
	JsonData []byte
	Url      *string `mandatory:"true" json:"url"`
	Type     string  `json:"type"`
}

// UnmarshalJSON unmarshals json
func (m *containerscanregistry) UnmarshalJSON(data []byte) error {
	m.JsonData = data
	type Unmarshalercontainerscanregistry containerscanregistry
	s := struct {
		Model Unmarshalercontainerscanregistry
	}{}
	err := json.Unmarshal(data, &s.Model)
	if err != nil {
		return err
	}
	m.Url = s.Model.Url
	m.Type = s.Model.Type

	return err
}

// UnmarshalPolymorphicJSON unmarshals polymorphic json
func (m *containerscanregistry) UnmarshalPolymorphicJSON(data []byte) (interface{}, error) {

	if data == nil || string(data) == "null" {
		return nil, nil
	}

	var err error
	switch m.Type {
	case "OCIR":
		mm := OcirContainerScanRegistry{}
		err = json.Unmarshal(data, &mm)
		return mm, err
	default:
		return *m, nil
	}
}

//GetUrl returns Url
func (m containerscanregistry) GetUrl() *string {
	return m.Url
}

func (m containerscanregistry) String() string {
	return common.PointerString(m)
}

// ContainerScanRegistryTypeEnum Enum with underlying type: string
type ContainerScanRegistryTypeEnum string

// Set of constants representing the allowable values for ContainerScanRegistryTypeEnum
const (
	ContainerScanRegistryTypeOcir ContainerScanRegistryTypeEnum = "OCIR"
)

var mappingContainerScanRegistryType = map[string]ContainerScanRegistryTypeEnum{
	"OCIR": ContainerScanRegistryTypeOcir,
}

// GetContainerScanRegistryTypeEnumValues Enumerates the set of values for ContainerScanRegistryTypeEnum
func GetContainerScanRegistryTypeEnumValues() []ContainerScanRegistryTypeEnum {
	values := make([]ContainerScanRegistryTypeEnum, 0)
	for _, v := range mappingContainerScanRegistryType {
		values = append(values, v)
	}
	return values
}
