// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v45/common"
)

// HostEndpointProtectionScanResultEndpointProtection An endpoint protection found in a host scan
type HostEndpointProtectionScanResultEndpointProtection struct {

	// Name of endpoint protection service
	Service *string `mandatory:"true" json:"service"`

	// Configuration information for endpoint protection service at the time of scan
	ConfigurationFinding *string `mandatory:"true" json:"configurationFinding"`

	// Date and time endpoint protection signature was updated, as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeSignatureUpdated *common.SDKTime `mandatory:"true" json:"timeSignatureUpdated"`

	// Problem severity
	Severity ScanResultProblemSeverityEnum `mandatory:"true" json:"severity"`
}

func (m HostEndpointProtectionScanResultEndpointProtection) String() string {
	return common.PointerString(m)
}
