// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v45/common"
)

// HostPortScanResultOpenPort An open port found in a host port scan
type HostPortScanResultOpenPort struct {

	// Open port
	Port *int `mandatory:"true" json:"port"`

	// Protocol of the open port
	Protocol *string `mandatory:"true" json:"protocol"`

	// IP Address open port was found on
	IpAddress *string `mandatory:"true" json:"ipAddress"`

	// ID of the attached VNIC that exposed the IP Address scanned
	VnicId *string `mandatory:"true" json:"vnicId"`

	// Problem severity
	Severity ScanResultProblemSeverityEnum `mandatory:"true" json:"severity"`

	// Service running on the port (if detected)
	Service *string `mandatory:"false" json:"service"`
}

func (m HostPortScanResultOpenPort) String() string {
	return common.PointerString(m)
}
