// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v45/common"
)

// HostPortScanResultSummary A summary of a result for a host agent scan
type HostPortScanResultSummary struct {

	// Unique identifier of the scan
	Id *string `mandatory:"true" json:"id"`

	// Instance ID of the Compute Instance scanned
	InstanceId *string `mandatory:"true" json:"instanceId"`

	// Compartment ID of the resource. This is set to the same as the compartment ID of the scan target
	CompartmentId *string `mandatory:"true" json:"compartmentId"`

	// Highest problem severity in this report
	HighestProblemSeverity ScanResultProblemSeverityEnum `mandatory:"true" json:"highestProblemSeverity"`

	// Total number of open ports across all attached VNICs found in this scan
	OpenPortCount *int `mandatory:"true" json:"openPortCount"`

	// Date and time the scan was started, as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeStarted *common.SDKTime `mandatory:"true" json:"timeStarted"`

	// Date and time the scan was completed, as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeFinished *common.SDKTime `mandatory:"true" json:"timeFinished"`

	// Name of the resource
	DisplayName *string `mandatory:"false" json:"displayName"`

	// The current state of the result.
	LifecycleState LifecycleStateEnum `mandatory:"false" json:"lifecycleState,omitempty"`
}

func (m HostPortScanResultSummary) String() string {
	return common.PointerString(m)
}
